#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>
#include "readdata.h"


/* Private variables */
static FILE	*fpdata;	/* data file */
static char basedir[MAXPATHLEN];/* data file base dir path */


/*
  Open data file

  Return value
  True: Success
  False: Failure
  */
int
datainit(const char *filename)
{
	int		len_basedir;
	char	*end;
	
	if ((fpdata = fopen(filename, "r")) == NULL) {
		return False;
	}

	/* Initialize basedir */
	end = strrchr(filename, '/');
	if (end == NULL) {
		basedir[0] = '\0';
	}
	else {
		len_basedir = end - filename + 1;
		memcpy(basedir, filename, len_basedir);
		basedir[len_basedir+1] = '\0';
	}

	return True;
}

void
dataterm(void)
{
	if (fpdata)
		fclose(fpdata);
}

/*
  int getvalue(char *value, const char *key)

  INPUT:
  const char *key;	
  OUTPUT:
  char *value;
  Return value; True:
  */
int
getvalue(char *value, const char *key)
{
	char	buf[BUFSIZ];
	int		lenkey = strlen(key);
	int		lenvalue;
	char	*ptr;
	char	*last;
	
	while (fgets(buf, BUFSIZ, fpdata)) {
		if (buf[0] == '#')
			continue;
		/* skip space etc. */
		ptr = &buf[strspn(buf, " \t\n\r")];
		if (*ptr == '\0')
			continue;
		if (strncasecmp(ptr, key, lenkey) == 0) {
			ptr += lenkey;
			ptr += strspn(ptr, " \t\n\r");
			if (*ptr != '\0') {
				lenvalue = strcspn(ptr, "\r\n");
				strncpy(value, ptr, lenvalue);
				value[lenvalue] = '\0';
				return True;
			}
		}
	}
	return False;
}


/*
  This function is made by inspiration by xancur.c(xancur).
  */
char *
EnrootPathName(char *orig)
{
	char	tmp[MAXPATHLEN];

	if (basedir[0] == '\0') {
		return orig;
	}

	/* Keep */
	strcpy(tmp, orig);

	strcpy(orig, basedir);
	strcat(orig, tmp);
	return orig;
}
