/****************************************************************************/
/* This module is based on xeyes, but has been siginificantly modified      */
/* by INOUE Seiichiro (inoue@ainet.or.jp)			                        */
/****************************************************************************/
/*
 * header file for transformed coordinate system.  No rotations
 * supported, as elipses cannot be rotated in X.
 */

typedef struct _transform {
	double	mx, bx;
	double	my, by;
} Transform;

typedef struct _TPoint {
	double	x, y;
} TPoint;

typedef struct _TRectangle {
	double	x, y, width, height;
} TRectangle;

# define Xx(x,y,t)	((int)((t)->mx * (x) + (t)->bx + 0.5))
# define Xy(x,y,t)	((int)((t)->my * (y) + (t)->by + 0.5))
# define Xwidth(w,h,t)	((int)((t)->mx * (w) + 0.5))
# define Xheight(w,h,t)	((int)((t)->my * (h) + 0.5))
# define Tx(x,y,t)	((((double) (x)) - (t)->bx) / (t)->mx)
# define Ty(x,y,t)	((((double) (y)) - (t)->by) / (t)->my)
# define Twidth(w,h,t)	(((double) (w)) / (t)->mx)
# define Theight(w,h,t)	(((double) (h)) / (t)->my)


typedef struct {
	/* center point */
	double	cx;
	double	cy;
	/* offset */
	double	offw;
	double	offh;
	/* radius */
	double	hw;
	double	hh;
	/* distance */
	double	dist;
} TAnimArea;


/* Global function prototype declarations */
extern void TCopyArea(Drawable src, Drawable dest, GC gc, Transform *t,
					  double sx, double sy, int width, int height, double dx, double dy);
extern void TCopyArea2(Drawable src, Drawable dest, GC gc, Transform *t,
					   int sx, int sy, int width, int height, double dx, double dy);
extern void TSetClipOrigin(GC gc, double x, double y, Transform *t);
extern void SetTransform(Transform *t, int xx1, int xx2, int xy1, int xy2,
						 double tx1, double tx2, double ty1, double ty2);
extern int SetTAnimArea(TAnimArea *taArea,
						 int wArea, int hArea, int w, int h, int cx, int cy);



